unit u_srctemp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls;

type
  Tsrctemp = class(TObject)
  Constructor Create(Dateiname : string);
  Destructor Free;
  function SubItemList   : TStringList;
  function ValueItemList : TStringList;
  procedure GetHDLSrc(var SrcList : TStringList;SubItem : string);
  private
    { Private-Deklarationen }
    SubItems,Value,TextList : TStringList;
  public
    { Public-Deklarationen }
  end;

implementation

Constructor Tsrctemp.Create(Dateiname : string);
var F    : TextFile;
    s,vs : string;
    b    : boolean;
begin
  SubItems:= TStringList.Create;
  Value:= TStringList.Create;
  TextList:= TStringList.Create;

  assignfile(F,Dateiname);
  {$I-}
  reset(F);
  {$I+}
  if ioresult = 0 then
  begin
    b:= false;
    while not eof(F) do
    begin
      readln(F,s);
      TextList.Add(s);

      if s <> '' then
      begin

        if (b = true) then
        begin
          if s[1] = '-' then vs:= vs + copy(s,2,length(s)-1) + '|';
          if ((s[1] = '<') or (s[1] ='#')) then
          begin
            b:= false;
            value.Add(vs);
            vs:='';
          end;
        end;

        if s[1] = '#' then
        begin
          SubItems.Add(copy(s,2,length(s)-1));
          b:= true;
          vs:='';
        end;

      end
      else begin
             if vs <> '' then value.Add(vs);
             vs:='';
             b:= false;
           end;
    end;
    {$I-}
    CloseFile(F);
    {$I-}
  end;
end;

Destructor Tsrctemp.Free;
begin
  SubItems.Free;
  Value.Free;
  TextList.Free;
end;

function Tsrctemp.SubItemList : TStringList;
begin
  result:= SubItems;
end;

function Tsrctemp.ValueItemList : TStringList;
begin
  result:= Value;
end;

procedure Tsrctemp.GetHDLSrc(var SrcList : TStringList;SubItem : string);
var s,sx    : string;
    i       : integer;
    b,bt,be : boolean;
begin
  if ((SrcList <> nil) and (TextList.Count > 0)) then
  begin
    i:= 0;
    b:= false;
    //Finde SubItem
    s:= '#'+uppercase(SubItem);
    while ((i < TextList.Count) and (b = false)) do
    begin
      sx:= uppercase(TextList.Strings[i]);
      if sx = s then b:= true
                else inc(i);
    end;

    inc(i);
    if b = true then //Subitem wurde gefunden
    begin
      bt:= false;
      //finde SRC
      while ((i < TextList.Count) and (bt = false)) do
      begin
        sx:= TextList.Strings[i];
        if sx <> '' then
        begin
          if sx[1] = '<' then bt:= true;
        end;
        inc(i);
      end;

      if bt = true then //SRC Anfang gefunden
      begin
        be:= false;
        while ((i < TextList.Count) and (be = false)) do
        begin
          sx:= TextList.Strings[i];
          if sx <> '' then
          begin
            if sx[1] = '>' then be:= true;
          end;
          if not(be) then SrcList.Add(sx);
          inc(i);
        end;
      end; //SRC kopiert
    end; //Subitem
  end;
end;

end.
